﻿/*
 * Instar Camera Interface
 * 
 * Hosted on codeplex: http://ici.codeplex.com
 * Camera devices: http://www.instar.de/
 * Author: Sebastian Kraemer, Sebastian.Kraemer@swKraemer.de
 *
 */

namespace InstarCameraInterface
{

    /// <summary>
    /// This abstract class is the base class for all instar camera interface - classes.
    /// It offers a property to the InstarCamera object this object belongs to.
    /// </summary>
    public abstract class InstarCameraClassBase
    {

        public InstarCameraClassBase(InstarCamera camera) {


            // Create info-debug-message
            System.Diagnostics.Debug.WriteLine(string.Format("New instance created: {0}", this.GetType().ToString()));

            // Check the validity of the camera-argument
            System.Diagnostics.Debug.Assert(camera != null, "Error: Class created without valid camera parameter.");
            
            // Save the parent camera object
            this.Camera = camera;
        
        }

        /// <summary>
        /// Returns the InstarCamera object this class referres to.
        /// </summary>
        public InstarCamera Camera {get; private set;}
    }
}
