﻿/*
 * Instar Camera Interface
 * 
 * Hosted on codeplex: http://ici.codeplex.com
 * Camera devices: http://www.instar.de/
 * Author: Sebastian Kraemer, Sebastian.Kraemer@swKraemer.de
 *
 */
using System;

namespace InstarCameraInterface
{
    public class InstarCameraNetwork : InstarCameraClassBase
    {

        public InstarCameraNetwork(InstarCamera camera) : base(camera) {  }


        public Boolean Change(int port)
        {
            return this.Change("", "", "", "", port);
        }

        public Boolean Change(string Ip4Address, string SubnetMask, string Gateway, string dns, int port)
        {
            ///set_network.cgi?ip=&mask=&gateway=&dns=&port=[&next_url=]
            ///Ip:ip address; if ip set null,The device will DHCP Ip
            String filename = "set_network.cgi";
            String parameter = String.Format("ip={0}&mask={1}&gateway={2}&dns={3}&port={4}", Ip4Address, SubnetMask, Gateway, dns, port);

            Boolean success = InstarCameraHelper.ExecuteHttpCommand(filename, parameter, this.Camera);
            if (success) this.Camera.Configuration.Reload();

            this.Camera.Configuration.Invalide();

            //Don't forget to reboot

            return success;
        }


        public String IpAddress { get { return this.Camera.Configuration.GetValueByName("ip").PropertyValue; } }

        public String SubnetMask { get { return this.Camera.Configuration.GetValueByName("mask").PropertyValue; } }

        public String Gateway { get { return this.Camera.Configuration.GetValueByName("gateway").PropertyValue; } }

        public String Dns { get { return this.Camera.Configuration.GetValueByName("dns").PropertyValue; } }

        public int Port { get { return  int.Parse(this.Camera.Configuration.GetValueByName("port").PropertyValue); } }
    }
}
