﻿/*
 * Instar Camera Interface
 * 
 * Hosted on codeplex: http://ici.codeplex.com
 * Camera devices: http://www.instar.de/
 * Author: Sebastian Kraemer, Sebastian.Kraemer@swKraemer.de
 *
 */
using System;
using System.Drawing;

namespace InstarCameraInterface
{
    public class InstarCameraSnapshot : InstarCameraClassBase 
    {
        private Object thisLock = new Object();

        public InstarCameraSnapshot(InstarCamera camera) :base(camera) {  this.TextColor = Color.MediumVioletRed; }

        

        public enum ResolutionEnum { x320y240 = 8, x640y480 = 32}

        public ResolutionEnum ImageResolution { get; set; }

        public String TextInImage { get; set; }

        public Color TextColor { get; set; }
        

        public System.Drawing.Image Create() 
        {

            lock(thisLock)
            {

                String Url = Camera.Connection.FullCameraAddressWithCredentials("snapshot.cgi");
                Url += string.Format("&resolution={0}", (int)this.ImageResolution);

                Image img = HttpHelper.GetContentImage(Url, this.Camera.Connection.Timeout);

                Size TmpSize = new Size();
                SolidBrush Brush = new SolidBrush(this.TextColor);

                TmpSize.Height = img.Height;
                TmpSize.Width = img.Width;

            
                Graphics  Graphic = System.Drawing.Graphics.FromImage(img);

                Font fnt = new Font("Arial", 11);
                Graphic.DrawString(this.TextInImage, fnt, Brush, 10, 10);

                Graphic.DrawImage(img, new Point(0,0));
                return img;
            }
            

        
        }


    }
}
