﻿/*
 * Instar Camera Interface
 * 
 * Hosted on codeplex: http://ici.codeplex.com
 * Camera devices: http://www.instar.de/
 * Author: Sebastian Kraemer, Sebastian.Kraemer@swKraemer.de
 *
 */
namespace InstarCameraInterface
{
    public class InstarCameraStatus :InstarCameraClassBase
    {

        public InstarCameraStatus(InstarCamera camera) :base(camera) {
            this.List = new InstarCameraVarDeclarationList(this.Camera, "get_status.cgi");
            this.List.Load();
        }

      

        public InstarCameraVarDeclarationList List { get; private set; }


        public enum ddnsStatusEnum { 
            NoAction=0, 
            Connecting=1,
            CantConnectToServer=2, 
            DynDnsSucceded=3, 
            DynDnsFailed_ServerError=4,
            DynDnsFailed_IncorrectCredentials=5, 
            DynDnsFailed_NeedCredentiedUser=6, 
            DynDnsFailed_IllegalHostFormat=7, 
            DynDnsFailed_HostDoesNotExist=8, 
            DnyDnsFailed_HostDoesNotelongToYou=9,
            DynDnsFailed_ToManyOrToFewHosts=10,
            DynDnsFailed_TheHostIsBlockedForAbusing = 11,
            DynDnsFailed_BadReplyFromServer = 12,
            DynDnsFailed_BadReplyFromServer2 = 13,
            OrayFailed_BadReplyFromServer = 14,
            OrayFailed_IncorrectCredentials = 15,
            OrayFailed_IncorrectHostname = 16,
            OraySucceded = 17,
            Reserved1 = 18,
            Reserved2 = 19,
            Reserved3 = 20,
            Reserved4 = 21

        }

        public ddnsStatusEnum ddns_status {
            get {
                return (ddnsStatusEnum) int.Parse(this.List["ddns_status"].PropertyValue); 
                } 
            }

        public enum upnpStatusEnumeration
        {
            NoAction = 0,
            Succeded = 1,
            DeviceSystemError=2,
            ErrorsInNetworkCommunication=3,
            ErrorsInChatWituUPnpDevice=4,
            RejectedByUPnpDevice=5
        }

        public upnpStatusEnumeration upnp_status {
            get {
                return (upnpStatusEnumeration)int.Parse(this.List["upnp_status"].PropertyValue);
            }
        }
    }



}
