﻿/*
 * Instar Camera Interface
 * 
 * Hosted on codeplex: http://ici.codeplex.com
 * Camera devices: http://www.instar.de/
 * Author: Sebastian Kraemer, Sebastian.Kraemer@swKraemer.de
 *
 */

using System;
using System.Text.RegularExpressions;

namespace InstarCameraInterface
{
    public class InstarCameraVarDeclatation
    {

        //public enum ChangeStateEnum{unchanged, changed }

        public enum ValueDataTypeEnum { varchar, numeric }

        public InstarCameraVarDeclatation(String varNameValueDeclaration)
        {

            /*
             var dev9_user='';
             var dev9_pwd='';
             var ip='192.168.0.150';
             var mask='255.255.255.0';
             var wifi_encrypt=5;
             var wifi_defkey=0;
             */
            
            String VarCharRegEx = @"var([\s]*)(?<varName>[^/\r\n]+)([\s]*)=([\s]*)'(?<varValue>.*)';";
            String NumericRegEx = @"var([\s]*)(?<varName>[^/\r\n]+)([\s]*)=([\s]*)(?<varValue>[-]{0,1}[\d]+);";


            Match match = null;
            if (Regex.IsMatch(varNameValueDeclaration ,VarCharRegEx)) 
            {
                match = Regex.Match(varNameValueDeclaration, VarCharRegEx); 
                this.ValueDataType = ValueDataTypeEnum.varchar;
            }


            if (Regex.IsMatch(varNameValueDeclaration, NumericRegEx)) {
                match = Regex.Match(varNameValueDeclaration, NumericRegEx);
                this.ValueDataType = ValueDataTypeEnum.numeric ;
            }

            this.PropertyName = match.Groups["varName"].Value;
            this.PropertyValue = match.Groups["varValue"].Value;
            //this.PropertyState = ChangeStateEnum.unchanged;

        }



        public String PropertyName { get; private set; }

        //private string _PropertyValue = "";
        public String PropertyValue { get; private set; }
        //public ChangeStateEnum PropertyState { get; private set; }

        public ValueDataTypeEnum ValueDataType { get; private set; }

    }
}
